<?php
//
// phpSysInfo - A PHP System Information Script
// http://phpsysinfo.sourceforge.net/
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// $Id: proftpd.php,v 1.0 2003/11/14 22:22:22 precision Exp $

//
// xml_proftpd()
//
function xml_proftpd () {
    global $sysinfo;
    $proftpd = $sysinfo->proftpd();
//MountPoint - PID
//Type - loginname
//Device - status
//Percent - status_percent
//Free - client
//Used - server
//size - location

    $_text = "  <proftpd>\n";
    for ($i=0; $i<sizeof($proftpd); $i++) {
        $sum['size'] += $proftpd[$i]['size']; //
        $sum['used'] += $proftpd[$i]['used'];
        $sum['free'] += $proftpd[$i]['free']; 
        $_text .="    <connection>\n"
               . "      <PID>" . $proftpd[$i]['PID'] . "</PID>\n"
               . "      <loginname>" . $proftpd[$i]['loginname'] . "</loginname>\n"
               . "      <status>" . $proftpd[$i]['status'] . "</status>\n"
               . "      <status_percent>" . $proftpd[$i]['status_percent'] . "</status_percent>\n"
               . "      <client>" . $proftpd[$i]['client'] . "</client>\n"
               . "      <server>" . $proftpd[$i]['server'] . "</server>\n"
               . "      <location>" . $proftpd[$i]['location'] . "</location>\n"
               . "    </connection>\n";
    }
    $_text .= "  </proftpd>\n";
    return $_text;
}

//
// html_proftpd()
//
function html_proftpd () {
    global $XPath;
    global $text;

    $scale_factor = 0.5;

    $_text = '<table width="100%" align="center">'
           . '<tr><td align="left" valign="top"><font size="-1"><b>' . $text['PID'] . '</b></font></td>'
           . '<td align="left" valign="top"><font size="-1"><b>' . $text['loginname'] . '</b></font></td>'
           . '<td align="left" valign="top"><font size="-1"><b>' . $text['status'] . '</b></font></td>'
           . '<td align="left" valign="top"><font size="-1"><b>' . $text['status_percent'] . '</b></font></td>'
           . '<td align="right" valign="top"><font size="-1"><b>' . $text['client'] . '</b></font></td>'
           . '<td align="right" valign="top"><font size="-1"><b>' . $text['server'] . '</b></font></td>'
           . '<td align="right" valign="top"><font size="-1"><b>' . $text['location'] . '</b></font></td></tr>';

    for ($i=1; $i<sizeof($XPath->getDataParts('/phpsysinfo/proftpd')); $i++) {
        if ($XPath->match("/phpsysinfo/proftpd/connection[$i]/PID")) {
            $sum['size'] += $XPath->getData("/phpsysinfo/proftpd/connection[$i]/location");
            $sum['used'] += $XPath->getData("/phpsysinfo/proftpd/connection[$i]/server");
            $sum['free'] += $XPath->getData("/phpsysinfo/proftpd/connection[$i]/client");

            $_text .= "\t<tr>\n";
            $_text .= "\t\t<td align=\"left\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/PID") . "</font></td>\n";
            $_text .= "\t\t<td align=\"left\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/loginname") . "</font></td>\n";
            $_text .= "\t\t<td align=\"left\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/status") . "</font></td>\n";
            $_text .= "\t\t<td align=\"left\" valign=\"top\"><font size=\"-1\">";

            $_text .= create_bargraph($XPath->getData("/phpsysinfo/proftpd/connection[$i]/status_percent"), 100, $scale_factor , $XPath->getData("/phpsysinfo/proftpd/connection[$i]/loginname"));
            
            $_text .= "&nbsp;" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/status_percent") . "</font></td>\n";
            $_text .= "\t\t<td align=\"right\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/client") . "</font></td>\n";
            $_text .= "\t\t<td align=\"right\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/server") . "</font></td>\n";
            $_text .= "\t\t<td align=\"right\" valign=\"top\"><font size=\"-1\">" . $XPath->getData("/phpsysinfo/proftpd/connection[$i]/location") . "</font></td>\n";
            $_text .= "\t</tr>\n";
        }
    }
    $_text .= '</table>';

    return $_text;
}
?>
